'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Animated = require('react-native-web/dist/exports/Animated');

var _Animated2 = _interopRequireDefault(_Animated);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _throttleDebounce = require('throttle-debounce');

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _nodeToScrollState = require('./nodeToScrollState');

var _nodeToScrollState2 = _interopRequireDefault(_nodeToScrollState);

var _nodeChildrenToScrollState = require('./nodeChildrenToScrollState');

var _nodeChildrenToScrollState2 = _interopRequireDefault(_nodeChildrenToScrollState);

var _contextProviderShape = require('./contextProviderShape');

var _contextProviderShape2 = _interopRequireDefault(_contextProviderShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var scrollInitalState = {
  position: 0,
  positionRatio: 0,
  start: 0,
  end: 0,
  viewHeight: 0,
  scrollHeight: 0,
  ready: false,
  onStart: true,
  onMiddle: false,
  onEnd: false,
  children: [],
  // autoFrame: props.autoFrame,
  // autoScroll: props.autoScroll,
  originalPosition: null,
  changedPosition: null,
  timeStamp: null,
  scrolling: false,
  wheeling: false,
  touching: false,
  moving: false,
  resting: true,
  touches: [],
  deltaY: 0
};

var Scroller = function (_Component) {
  _inherits(Scroller, _Component);

  function Scroller(props) {
    _classCallCheck(this, Scroller);

    var _this = _possibleConstructorReturn(this, (Scroller.__proto__ || Object.getPrototypeOf(Scroller)).call(this, props));

    _this.createRef = function (ref) {
      _this.node = ref;

      // add component to resize observer to detect changes on resize
      _this.resizeObserver = new _resizeObserverPolyfill2.default(function (entries, observer) {
        if (_this.state.ready) {
          _this.handleResize();
        } else {
          _this.setStateScroll({
            ready: true
          });
        }
      });

      _this.resizeObserver.observe(_this.node);

      _this.props.scrollRef(_this.connection);
    };

    _this.deleteRef = function () {
      if (_this.node) {
        _this.resizeObserver.disconnect(_this.node);
      }

      _this.setStateScroll({
        ready: false
      });
    };

    _this.setStateScroll = function (additionalStates) {
      var onScrollChange = _this.props.onScrollChange;


      var newScroll = _extends({}, _this.state.scroll, (0, _nodeToScrollState2.default)(_this.node), (0, _nodeChildrenToScrollState2.default)(_this.node), additionalStates);

      _this.setState({ scroll: newScroll });

      if (onScrollChange) {
        onScrollChange(newScroll);
      }
    };

    _this.setStateScrollStart = function (additionalStates) {
      var position = _this.state.scroll.position;


      _this.setStateScroll(_extends({
        originalPosition: position,
        timeStamp: Date.now()
      }, additionalStates));
    };

    _this.setStateScrollMove = function (additionalStates) {
      _this.setStateScroll(_extends({
        moving: true,
        resting: false
      }, additionalStates));
    };

    _this.setStateScrollRest = function (additionalStates) {
      _this.setStateScroll(_extends({
        moving: false,
        resting: true
      }, additionalStates));
    };

    _this.setStateScrollEnd = function (additionalStates) {
      _this.setStateScroll(_extends({
        originalPosition: null,
        changedPosition: null,
        timeStamp: null
      }, additionalStates));
    };

    _this.findChildOnView = function () {
      var children = _this.state.scroll.children;


      return children.find(function (child) {
        return child.onView;
      });
    };

    _this.findChildIndexOnView = function () {
      var children = _this.state.scroll.children;


      return children.findIndex(function (child) {
        return child.onView;
      });
    };

    _this.scrollToPosition = function (position) {
      _Animated2.default.spring(_this.scrollValue, {
        toValue: position,
        stiffness: 170,
        damping: 26,
        useNativeDriver: true
      }).start();
    };

    _this.scrollToByIndex = function (index) {
      var children = _this.state.scroll.children;


      _this.scrollToPosition(children[index].start);
    };

    _this.scrollToTop = function () {
      var start = _this.state.scroll.start;


      _this.scrollToPosition(start);
    };

    _this.scrollToBottom = function () {
      var end = _this.state.scroll.end;


      _this.scrollToPosition(end);
    };

    _this.previousOfIndex = function () {
      var i = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.findChildIndexOnView();
      var arr = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.state.scroll.children;

      return arr[i > 0 ? i - 1 : i];
    };

    _this.nextOfIndex = function () {
      var i = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.findChildIndexOnView();
      var arr = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.state.scroll.children;

      return arr[i < arr.length - 1 ? i + 1 : i];
    };

    _this.scrollToPrev = function () {
      var prevPosition = _this.previousOfIndex().start;

      _this.scrollToPosition(prevPosition);
    };

    _this.scrollToNext = function () {
      var nextPosition = _this.nextOfIndex().start;

      _this.scrollToPosition(nextPosition);
    };

    _this.scrollToElement = function (element, options) {
      var start = element.scrollTop;

      _this.scrollToPosition(start);
    };

    _this.scrollToActive = function () {
      var newPosition = _this.findChildOnView().start;

      _this.scrollToPosition(newPosition);
    };

    _this.handleScroll = function () {
      _this.handleScrollStart();
      _this.handleScrollMove();
      _this.handleScrollEnd();
    };

    _this.handleScrollStart = function () {
      _this.setStateScrollMove();
    };

    _this.handleScrollMove = function () {
      _this.setStateScroll();
    };

    _this.handleScrollEnd = function () {
      _this.setStateScrollRest();
    };

    _this.handleResize = function () {
      _this.handleResizeStart();
      _this.handleResizeMove();
      _this.handleResizeEnd();
    };

    _this.handleResizeStart = function () {
      _this.setStateScrollMove();
    };

    _this.handleResizeMove = function () {
      _this.handleScroll();
    };

    _this.handleResizeEnd = function () {
      var autoFrame = _this.props.autoFrame;


      if (autoFrame) {
        _this.scrollToActive();
      }
    };

    _this.handleWheel = function (e) {
      var autoScroll = _this.props.autoScroll;


      if (autoScroll) {
        e.preventDefault();
      }

      _this.handleWheelStart(e);
      _this.handleWheelMove(e);
      _this.handleWheelEnd(e);
    };

    _this.handleWheelStart = function (e) {
      var autoScroll = _this.props.autoScroll;
      var changedPosition = _this.state.scroll.changedPosition;


      _this.setStateScrollStart({
        wheeling: true,
        changedPosition: !autoScroll ? null : changedPosition
      });

      if (autoScroll) {
        var movingUpwards = e.deltaY > 0;
        var movingDownwards = e.deltaY < 0;

        if (movingDownwards) _this.scrollToPrevDebounced();
        if (movingUpwards) _this.scrollToNextDebounced();
      }
    };

    _this.handleWheelMove = function (e) {
      var autoScroll = _this.props.autoScroll;


      if (autoScroll) {
        var prev = _this.state.deltaY;
        var next = e.deltaY;

        var changed = Math.abs(next) > Math.abs(prev);

        if (changed) {
          var movingUpwards = next > 0;
          var movingDownwards = next < 0;

          if (movingDownwards) {
            _this.scrollToPrevDebounced();
          }
          if (movingUpwards) {
            _this.scrollToNextDebounced();
          }
        }
      }

      _this.setState({ deltaY: e.deltaY });
    };

    _this.handleWheelEnd = function (e) {
      var autoFrame = _this.state.scroll.autoFrame;


      _this.setStateScrollEnd({
        wheeling: false,
        deltaY: null
      });

      if (autoFrame) _this.scrollToActive();
    };

    _this.handleTouchStart = function (e) {
      _this.setStateScrollStart({
        touching: true,
        touches: e.touches
      });
    };

    _this.handleTouchMove = function (e) {
      var _this$state$scroll = _this.state.scroll,
          touches = _this$state$scroll.touches,
          originalPosition = _this$state$scroll.originalPosition;


      var distanceFromTouchStart = e.changedTouches[0].clientY - touches[0].clientY;
      var touchPosition = originalPosition - distanceFromTouchStart;

      _this.scrollToPosition(touchPosition);
    };

    _this.handleTouchEnd = function (e) {
      var _this$state$scroll2 = _this.state.scroll,
          timeStamp = _this$state$scroll2.timeStamp,
          touches = _this$state$scroll2.touches;


      var timeLapse = Date.now() - timeStamp;

      if (timeLapse < 200) {
        var movingUpwards = e.changedTouches[0].clientY < touches[0].clientY;
        var movingDownwards = e.changedTouches[0].clientY > touches[0].clientY;

        if (movingDownwards) _this.scrollToPrev();
        if (movingUpwards) _this.scrollToNext();
      } else {
        _this.scrollToActive();
      }

      _this.setStateScroll({
        touching: false
      });
    };

    _this.state = {
      scroll: scrollInitalState
    };

    // debounce is used to mimiques start, move and end events that don't have this functions
    _this.handleScrollStart = (0, _throttleDebounce.debounce)(500, true, _this.handleScrollStart);
    _this.handleResizeMove = (0, _throttleDebounce.throttle)(50, _this.handleResizeMove);
    _this.handleScrollEnd = (0, _throttleDebounce.debounce)(500, _this.handleScrollEnd);
    _this.handleWheelStart = (0, _throttleDebounce.debounce)(100, true, _this.handleWheelStart);
    _this.handleWheelEnd = (0, _throttleDebounce.debounce)(100, _this.handleWheelEnd);
    _this.handleResizeStart = (0, _throttleDebounce.debounce)(250, true, _this.handleResizeStart);
    _this.handleResizeEnd = (0, _throttleDebounce.debounce)(250, _this.handleResizeEnd);

    _this.scrollToPrevDebounced = (0, _throttleDebounce.debounce)(250, true, _this.scrollToPrev);
    _this.scrollToNextDebounced = (0, _throttleDebounce.debounce)(250, true, _this.scrollToNext);

    _this.scrollValue = new _Animated2.default.Value(0);

    _this.scrollValue.addListener(function (_ref) {
      var value = _ref.value;

      // TODO: use setNative
      _this.node.scrollTop = Math.round(value);
    });
    return _this;
  }

  _createClass(Scroller, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.deleteRef();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          autoFrame = _props.autoFrame,
          autoScroll = _props.autoScroll,
          ScrollerNavigation = _props.ScrollerNavigation;


      return _react2.default.createElement(
        ScrollerContainer,
        null,
        _react2.default.createElement(ScrollerNavigation, {
          scroll: this.connection
        }),
        _react2.default.createElement(
          ScrollerContent,
          {
            scrollRef: this.createRef,
            scroll: this.state.scroll,
            onScroll: this.handleScroll,
            onWheel: this.handleWheel,
            onTouchStart: this.handleTouchStart,
            onTouchMove: this.handleTouchMove,
            onTouchEnd: this.handleTouchEnd
          },
          children
        )
      );
    }
  }, {
    key: 'connection',
    get: function get() {
      return _extends({}, this.state.scroll, {
        autoFrame: this.props.autoFrame,
        autoScroll: this.props.autoScroll,
        scrollToPosition: this.scrollToPosition,
        scrollToByIndex: this.scrollToByIndex,
        scrollToTop: this.scrollToTop,
        scrollToBottom: this.scrollToBottom,
        scrollToPrev: this.scrollToPrev,
        scrollToNext: this.scrollToNext,
        scrollToElement: this.scrollToElement,
        scrollToActive: this.scrollToActive
      });
    }
  }]);

  return Scroller;
}(_react.Component);

Scroller.defaultProps = {
  autoFrame: false,
  autoScroll: false,
  ScrollerNavigation: function ScrollerNavigation() {
    return null;
  }
};
exports.default = Scroller;

var ScrollerContainer = function (_Component2) {
  _inherits(ScrollerContainer, _Component2);

  function ScrollerContainer() {
    _classCallCheck(this, ScrollerContainer);

    return _possibleConstructorReturn(this, (ScrollerContainer.__proto__ || Object.getPrototypeOf(ScrollerContainer)).apply(this, arguments));
  }

  _createClass(ScrollerContainer, [{
    key: 'render',
    value: function render() {
      var style = {
        height: '100%',
        width: '100%'
      };

      return _react2.default.createElement('div', _extends({ style: style }, this.props));
    }
  }]);

  return ScrollerContainer;
}(_react.Component);

var ScrollerContent = function (_Component3) {
  _inherits(ScrollerContent, _Component3);

  function ScrollerContent() {
    _classCallCheck(this, ScrollerContent);

    return _possibleConstructorReturn(this, (ScrollerContent.__proto__ || Object.getPrototypeOf(ScrollerContent)).apply(this, arguments));
  }

  _createClass(ScrollerContent, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (Object.keys(nextProps).includes('scroll')) {
        return false;
      }

      return true;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          scroll = _props2.scroll,
          scrollRef = _props2.scrollRef,
          autoFrame = _props2.autoFrame,
          autoScroll = _props2.autoScroll,
          props = _objectWithoutProperties(_props2, ['scroll', 'scrollRef', 'autoFrame', 'autoScroll']);

      var style = {
        height: '100%',
        width: '100%',
        overflowY: autoScroll || scroll.touching ? 'hidden' : 'auto'
      };

      return _react2.default.createElement('div', _extends({
        ref: scrollRef,
        style: style
      }, props));
    }
  }]);

  return ScrollerContent;
}(_react.Component);